#include "asm86.h"
#include "ti86asm.inc"

.org $d748

     call _runindicoff
     call $49dc
TheBegin:
        call _clrlcd
        ld hl,$0003
        ld (_curRow),hl
        ld hl,Info
        set 3,(iy+5)
        call _puts
        res 3,(iy+5)
        ld hl,$3A62
        ld (_penCol),hl
        ld hl,EnterStr
        call _vputs
        call WAIT_KEY

        call _clrlcd
        ld bc,$1001
LoopThicken:
        call FIND_PIXEL
        ld hl,_plotSScreen-$FC00
        add hl,de
        and (hl)
        jr z,NextThicken
        dec b
        dec c
        call PT_ON
        inc c
        call PT_ON
        inc c
        call PT_ON
        inc b
        call PT_ON
        dec c
        call PT_ON
        dec c
        call PT_ON
        inc b
        call PT_ON
        inc c
        call PT_ON
        inc c
        call PT_ON
        dec b
        dec c
NextThicken:
        inc b
        ld a,b
        cp 126
        jr c,LoopThicken
        ld b,$10
        inc c
        ld a,c
        cp 63
        jr c,LoopThicken
        call WAIT_KEY
        cp K_ENTER
        ret nz

        ld hl,$FC00
        ld b,63
RDStare:
        push hl
        ld hl,(RNSeed)
        ld a,h
        rlca
        inc a
        xor l
        ld h,a
        ld a,l
        rra
        inc a
        xor h
        ld l,a
        ld (RNSeed),hl
        ex de,hl
        pop hl
        ld (hl),e
        inc hl
        ld (hl),d
        dec hl
        ld de,$0010
        add hl,de
        djnz RDStare

        ld bc,$1000
Loop:
        call PT_TST
        or a
        jr z,No1
        ld a,b
        sub $10
        ld b,a
        call PT_TST
        or a
        jr z,No2
        ld a,b
        add a,$0F
        ld b,a
        call PT_ON
        inc b
        jr No1
No2:
        ld a,b
        add a,$0F
        ld b,a
        call PT_OFF
        inc b
No1:
        ld a,b
        sub $10
        ld b,a
        call PT_TST
        or a
        jr z,No3
        ld a,b
        add a,$10
        ld b,a
        call PT_ON
        jr Ok
No3:
        ld a,b
        add a,$10
        ld b,a
        call PT_TST
Ok:
        inc b
        ld a,b
        cp 126
        jr c,Loop
        ld b,$10
        inc c
        ld a,c
        cp 64
        jr c,Loop
        call WAIT_KEY
        cp K_ENTER
        jr nz,_exit
        ld hl,$FC00
        ld de,_plotSScreen
        ld bc,$0400
        ldir
        ld hl,$0003
        ld (_curRow),hl
        ld hl,PicSaved
        call _puts
        ld b,0
        halt
        djnz $-1
_exit:
        call _clrscrn
        jp _homeup

PicSaved:
        .db "    PICTURE SAVED    ",0
Info:
        .db "Stereogram Engine 2.2"
        .db " (C) 1997 Kirk Meyer ",0
EnterStr:
        .db "Hit Enter",0

savevar = $ - 1
 .db $06,"stareo"

WAIT_KEY:
     push hl
WAIT_KEY_L:
     halt
     call $4068
     or a
     jr z,WAIT_KEY_L
     pop hl
     ret

RNSeed:
.dw $C581

PT_ON:
        push hl
        push de
        call FIND_PIXEL
        ex de,hl
        or (hl)
        ld (hl),a
        pop de
        pop hl
        ret

PT_OFF:
        push hl
        push de
        call FIND_PIXEL
        ex de,hl
        xor $FF
        and (hl)
        ld (hl),a
        pop de
        pop hl
        ret

PT_TST:
        push hl
        push de
        call FIND_PIXEL
        ex de,hl
        and (hl)
        pop de
        pop hl
        ret

FIND_PIXEL:
     push bc
     ld a,$3F
     sub c
     ld   c,a

     ld   a,b
     and  $07
     or   FindPixelTable&255
     ld   l,a
     ld   h,FindPixelTable/256
     ld   d,$3F
     ld   a,c
     add  a,a
     add  a,a
     add  a,a
     rl   d
     add  a,a
     rl   d
     srl  b
     srl  b
     srl  b
     or   b
     ld   e,a
     ld   a,(hl)
     pop bc
     ret

.org (($-1)|7)+1
FindPixelTable:
     .db $80,$40,$20,$10,$08,$04,$02,$01

.end
